/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ContactAvatars type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactAvatars{}

// ContactAvatars struct for ContactAvatars
type ContactAvatars struct {
	// Profile image URL
	Primary *string `json:"primary,omitempty"`
	// Additional profile images in JSON format: { [source]: [url] }
	Additional *map[string]string `json:"additional,omitempty"`
}

// NewContactAvatars instantiates a new ContactAvatars object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactAvatars() *ContactAvatars {
	this := ContactAvatars{}
	return &this
}

// NewContactAvatarsWithDefaults instantiates a new ContactAvatars object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactAvatarsWithDefaults() *ContactAvatars {
	this := ContactAvatars{}
	return &this
}

// GetPrimary returns the Primary field value if set, zero value otherwise.
func (o *ContactAvatars) GetPrimary() string {
	if o == nil || IsNil(o.Primary) {
		var ret string
		return ret
	}
	return *o.Primary
}

// GetPrimaryOk returns a tuple with the Primary field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAvatars) GetPrimaryOk() (*string, bool) {
	if o == nil || IsNil(o.Primary) {
		return nil, false
	}
	return o.Primary, true
}

// HasPrimary returns a boolean if a field has been set.
func (o *ContactAvatars) HasPrimary() bool {
	if o != nil && !IsNil(o.Primary) {
		return true
	}

	return false
}

// SetPrimary gets a reference to the given string and assigns it to the Primary field.
func (o *ContactAvatars) SetPrimary(v string) {
	o.Primary = &v
}

// GetAdditional returns the Additional field value if set, zero value otherwise.
func (o *ContactAvatars) GetAdditional() map[string]string {
	if o == nil || IsNil(o.Additional) {
		var ret map[string]string
		return ret
	}
	return *o.Additional
}

// GetAdditionalOk returns a tuple with the Additional field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAvatars) GetAdditionalOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Additional) {
		return nil, false
	}
	return o.Additional, true
}

// HasAdditional returns a boolean if a field has been set.
func (o *ContactAvatars) HasAdditional() bool {
	if o != nil && !IsNil(o.Additional) {
		return true
	}

	return false
}

// SetAdditional gets a reference to the given map[string]string and assigns it to the Additional field.
func (o *ContactAvatars) SetAdditional(v map[string]string) {
	o.Additional = &v
}

func (o ContactAvatars) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactAvatars) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Primary) {
		toSerialize["primary"] = o.Primary
	}
	if !IsNil(o.Additional) {
		toSerialize["additional"] = o.Additional
	}
	return toSerialize, nil
}

type NullableContactAvatars struct {
	value *ContactAvatars
	isSet bool
}

func (v NullableContactAvatars) Get() *ContactAvatars {
	return v.value
}

func (v *NullableContactAvatars) Set(val *ContactAvatars) {
	v.value = val
	v.isSet = true
}

func (v NullableContactAvatars) IsSet() bool {
	return v.isSet
}

func (v *NullableContactAvatars) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactAvatars(val *ContactAvatars) *NullableContactAvatars {
	return &NullableContactAvatars{value: val, isSet: true}
}

func (v NullableContactAvatars) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactAvatars) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


